using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.IO;
using System.Text.RegularExpressions;

namespace PhidgetLauncher
{

	/// <summary>
	/// o^ItemǗEҏWForm
	/// </summary>
	
	public class ItemForm : System.Windows.Forms.Form
	{

		#region GUIR|[lg̐錾
		private System.Windows.Forms.TextBox textBoxId;
		private System.Windows.Forms.Label labelId;
		private System.Windows.Forms.Label labelTitle;
		private System.Windows.Forms.Label labelName;
		private System.Windows.Forms.TextBox textBoxName;
		private System.Windows.Forms.Button buttonOK;
		private System.Windows.Forms.Button buttonCancel;
		private System.Windows.Forms.Label labelProgram;
		private System.Windows.Forms.Button buttonFileDialog1;
		private System.Windows.Forms.Button buttonFileDialog2;
		private System.Windows.Forms.Label labelOption;
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.Label labelProgram2;
		private System.Windows.Forms.Button buttonFileDialog3;
		private System.Windows.Forms.Label labelOption2;
		private System.Windows.Forms.Button buttonFileDialog4;
		private System.Windows.Forms.GroupBox groupBoxRecognize;
		private System.Windows.Forms.GroupBox groupBoxRemove;
		private System.Windows.Forms.TextBox textBoxProgramStart;
		private System.Windows.Forms.TextBox textBoxOptionStart;
		private System.Windows.Forms.TextBox textBoxOptionEnd;
		private System.Windows.Forms.TextBox textBoxProgramEnd;
		#endregion
		
		public Item item;
		private string lastDirectory = "";

		#region RXgN^/fXgN^
		
		public ItemForm(Item item)
		{
			InitializeComponent();
			
			this.item = item;
			textBoxId.Text = item.id.ToString();
			textBoxName.Text = item.name;
			textBoxProgramStart.Text = item.programStart;
			textBoxProgramEnd.Text = item.programEnd;
			foreach(string option in item.optionsStart)
			{
				textBoxOptionStart.Text = textBoxOptionStart.Text +  Item.DELIMITER + option;
			}
			textBoxOptionStart.Text = Regex.Replace(textBoxOptionStart.Text, "^" + Item.DELIMITER, "");
			
			foreach(string option in item.optionsEnd)
			{
				textBoxOptionEnd.Text = textBoxOptionEnd.Text +  Item.DELIMITER + option;
			}
			textBoxOptionEnd.Text = Regex.Replace(textBoxOptionEnd.Text, "^" + Item.DELIMITER, "");
		}

		
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#endregion

		#region t@C_CAȌ

		//Programpt@C_CAOJD
		private bool LoadFileDialogProgram(ref string  fileName)
		{
			OpenFileDialog openDialog = new OpenFileDialog();
			openDialog.InitialDirectory = Application.StartupPath;
			openDialog.Filter = "exe files (*.exe)|*.exe|all files (*.*)|*.*" ;
			openDialog.FilterIndex = 1 ;
			openDialog.RestoreDirectory = true;
			openDialog.Multiselect = false;

			if(lastDirectory != "")
			{
				openDialog.InitialDirectory = lastDirectory;
			}

			if(openDialog.ShowDialog() == DialogResult.OK && openDialog.FileName != "")
			{
				DialogResult = DialogResult.None;
				fileName = openDialog.FileName;
				return true;
			}
			else
			{
				DialogResult = DialogResult.None;
				return false;
			}
		}

		//Optionpt@C_CAOJD
		private bool LoadFileDialogOptions(ref string [] fileNames)
		{
			OpenFileDialog openDialog = new OpenFileDialog();
			openDialog.InitialDirectory = Application.StartupPath;
			openDialog.Filter = "all files (*.*)|*.*" ;
			openDialog.FilterIndex = 1 ;
			openDialog.RestoreDirectory = true ;
			openDialog.Multiselect = true;

			if(lastDirectory!="")
			{
				openDialog.InitialDirectory = lastDirectory;
			}

			if(openDialog.ShowDialog() == DialogResult.OK && openDialog.FileNames.Length > 0)
			{	
				DialogResult = DialogResult.None;
				fileNames = openDialog.FileNames;
				return true;
			}
			else
			{
				DialogResult = DialogResult.None;
				return false;
			}
		}

		#endregion

		#region GUIR|[lg̃Cxg
		
		private void buttonOK_Click(object sender, System.EventArgs e)
		{
			item.name = textBoxName.Text;
			item.programStart = textBoxProgramStart.Text;
			item.optionsStart = textBoxOptionStart.Text.Split(Item.DELIMITER.ToCharArray());
			item.programEnd = textBoxProgramEnd.Text;
			item.optionsEnd = textBoxOptionEnd.Text.Split(Item.DELIMITER.ToCharArray());
			return;
		}

		private void buttonFileDialog1_Click(object sender, System.EventArgs e)
		{
			string fileName = "";

			if(LoadFileDialogProgram(ref fileName))
			{
				textBoxProgramStart.Text = fileName;
				lastDirectory = Path.GetDirectoryName(fileName);
			}
		}

		private void buttonFileDialog2_Click(object sender, System.EventArgs e)
		{
			string [] fileNames = null;

			if(LoadFileDialogOptions(ref fileNames))
			{
				foreach(string filename in fileNames)
				{
					textBoxOptionStart.Text = filename + Item.DELIMITER + textBoxOptionStart.Text;
				}
				lastDirectory = Path.GetDirectoryName(fileNames[0]);
			}
		}

		private void buttonFileDialog3_Click(object sender, System.EventArgs e)
		{
			string fileName = "";

			if(LoadFileDialogProgram(ref fileName))
			{
				textBoxProgramEnd.Text = fileName;
				lastDirectory = Path.GetDirectoryName(fileName);
			}
		}

		private void buttonFileDialog4_Click(object sender, System.EventArgs e)
		{
			string [] fileNames = null;

			if(LoadFileDialogOptions(ref fileNames))
			{
				foreach(string filename in fileNames)
				{
					textBoxOptionEnd.Text = filename + Item.DELIMITER + textBoxOptionStart.Text;
				}
				lastDirectory = Path.GetDirectoryName(fileNames[0]);
			}
		}

		#endregion
		
		#region Windows Form Designer generated code
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{
			this.textBoxId = new System.Windows.Forms.TextBox();
			this.labelId = new System.Windows.Forms.Label();
			this.labelTitle = new System.Windows.Forms.Label();
			this.labelName = new System.Windows.Forms.Label();
			this.textBoxName = new System.Windows.Forms.TextBox();
			this.labelProgram = new System.Windows.Forms.Label();
			this.textBoxProgramStart = new System.Windows.Forms.TextBox();
			this.buttonOK = new System.Windows.Forms.Button();
			this.buttonCancel = new System.Windows.Forms.Button();
			this.textBoxOptionStart = new System.Windows.Forms.TextBox();
			this.labelOption = new System.Windows.Forms.Label();
			this.buttonFileDialog1 = new System.Windows.Forms.Button();
			this.buttonFileDialog2 = new System.Windows.Forms.Button();
			this.groupBoxRecognize = new System.Windows.Forms.GroupBox();
			this.groupBoxRemove = new System.Windows.Forms.GroupBox();
			this.labelProgram2 = new System.Windows.Forms.Label();
			this.buttonFileDialog3 = new System.Windows.Forms.Button();
			this.textBoxOptionEnd = new System.Windows.Forms.TextBox();
			this.textBoxProgramEnd = new System.Windows.Forms.TextBox();
			this.labelOption2 = new System.Windows.Forms.Label();
			this.buttonFileDialog4 = new System.Windows.Forms.Button();
			this.groupBoxRecognize.SuspendLayout();
			this.groupBoxRemove.SuspendLayout();
			this.SuspendLayout();
			// 
			// textBoxId
			// 
			this.textBoxId.Location = new System.Drawing.Point(72, 32);
			this.textBoxId.Name = "textBoxId";
			this.textBoxId.ReadOnly = true;
			this.textBoxId.Size = new System.Drawing.Size(160, 19);
			this.textBoxId.TabIndex = 0;
			this.textBoxId.Text = "";
			// 
			// labelId
			// 
			this.labelId.Location = new System.Drawing.Point(16, 32);
			this.labelId.Name = "labelId";
			this.labelId.Size = new System.Drawing.Size(24, 23);
			this.labelId.TabIndex = 1;
			this.labelId.Text = "ID:";
			// 
			// labelTitle
			// 
			this.labelTitle.Location = new System.Drawing.Point(8, 8);
			this.labelTitle.Name = "labelTitle";
			this.labelTitle.Size = new System.Drawing.Size(216, 16);
			this.labelTitle.TabIndex = 2;
			this.labelTitle.Text = "IDɑΉL[[hȂǂo^܂";
			// 
			// labelName
			// 
			this.labelName.Location = new System.Drawing.Point(16, 72);
			this.labelName.Name = "labelName";
			this.labelName.Size = new System.Drawing.Size(48, 16);
			this.labelName.TabIndex = 3;
			this.labelName.Text = "Name:";
			// 
			// textBoxName
			// 
			this.textBoxName.Location = new System.Drawing.Point(72, 72);
			this.textBoxName.Name = "textBoxName";
			this.textBoxName.Size = new System.Drawing.Size(160, 19);
			this.textBoxName.TabIndex = 1;
			this.textBoxName.Text = "";
			// 
			// labelProgram
			// 
			this.labelProgram.Location = new System.Drawing.Point(8, 24);
			this.labelProgram.Name = "labelProgram";
			this.labelProgram.Size = new System.Drawing.Size(56, 16);
			this.labelProgram.TabIndex = 5;
			this.labelProgram.Text = "Program:";
			// 
			// textBoxProgramStart
			// 
			this.textBoxProgramStart.Location = new System.Drawing.Point(72, 24);
			this.textBoxProgramStart.Name = "textBoxProgramStart";
			this.textBoxProgramStart.Size = new System.Drawing.Size(160, 19);
			this.textBoxProgramStart.TabIndex = 2;
			this.textBoxProgramStart.Text = "";
			// 
			// buttonOK
			// 
			this.buttonOK.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.buttonOK.Location = new System.Drawing.Point(72, 312);
			this.buttonOK.Name = "buttonOK";
			this.buttonOK.Size = new System.Drawing.Size(56, 23);
			this.buttonOK.TabIndex = 10;
			this.buttonOK.Text = "o^";
			this.buttonOK.Click += new System.EventHandler(this.buttonOK_Click);
			// 
			// buttonCancel
			// 
			this.buttonCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.buttonCancel.Location = new System.Drawing.Point(168, 312);
			this.buttonCancel.Name = "buttonCancel";
			this.buttonCancel.TabIndex = 11;
			this.buttonCancel.Text = "LZ";
			// 
			// textBoxOptionStart
			// 
			this.textBoxOptionStart.Location = new System.Drawing.Point(72, 64);
			this.textBoxOptionStart.Name = "textBoxOptionStart";
			this.textBoxOptionStart.Size = new System.Drawing.Size(160, 19);
			this.textBoxOptionStart.TabIndex = 4;
			this.textBoxOptionStart.Text = "";
			// 
			// labelOption
			// 
			this.labelOption.Location = new System.Drawing.Point(16, 64);
			this.labelOption.Name = "labelOption";
			this.labelOption.Size = new System.Drawing.Size(48, 16);
			this.labelOption.TabIndex = 9;
			this.labelOption.Text = "Option:";
			// 
			// buttonFileDialog1
			// 
			this.buttonFileDialog1.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.buttonFileDialog1.Location = new System.Drawing.Point(248, 24);
			this.buttonFileDialog1.Name = "buttonFileDialog1";
			this.buttonFileDialog1.Size = new System.Drawing.Size(56, 23);
			this.buttonFileDialog1.TabIndex = 3;
			this.buttonFileDialog1.Text = "Q";
			this.buttonFileDialog1.Click += new System.EventHandler(this.buttonFileDialog1_Click);
			// 
			// buttonFileDialog2
			// 
			this.buttonFileDialog2.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.buttonFileDialog2.Location = new System.Drawing.Point(248, 64);
			this.buttonFileDialog2.Name = "buttonFileDialog2";
			this.buttonFileDialog2.Size = new System.Drawing.Size(56, 23);
			this.buttonFileDialog2.TabIndex = 5;
			this.buttonFileDialog2.Text = "Q";
			this.buttonFileDialog2.Click += new System.EventHandler(this.buttonFileDialog2_Click);
			// 
			// groupBoxRecognize
			// 
			this.groupBoxRecognize.Controls.AddRange(new System.Windows.Forms.Control[] {
																							this.labelProgram,
																							this.buttonFileDialog1,
																							this.textBoxOptionStart,
																							this.textBoxProgramStart,
																							this.labelOption,
																							this.buttonFileDialog2});
			this.groupBoxRecognize.Location = new System.Drawing.Point(8, 104);
			this.groupBoxRecognize.Name = "groupBoxRecognize";
			this.groupBoxRecognize.Size = new System.Drawing.Size(312, 96);
			this.groupBoxRecognize.TabIndex = 2;
			this.groupBoxRecognize.TabStop = false;
			this.groupBoxRecognize.Text = "F̏";
			// 
			// groupBoxRemove
			// 
			this.groupBoxRemove.Controls.AddRange(new System.Windows.Forms.Control[] {
																						 this.labelProgram2,
																						 this.buttonFileDialog3,
																						 this.textBoxOptionEnd,
																						 this.textBoxProgramEnd,
																						 this.labelOption2,
																						 this.buttonFileDialog4});
			this.groupBoxRemove.Location = new System.Drawing.Point(5, 208);
			this.groupBoxRemove.Name = "groupBoxRemove";
			this.groupBoxRemove.Size = new System.Drawing.Size(312, 96);
			this.groupBoxRemove.TabIndex = 6;
			this.groupBoxRemove.TabStop = false;
			this.groupBoxRemove.Text = "̏";
			// 
			// labelProgram2
			// 
			this.labelProgram2.Location = new System.Drawing.Point(8, 24);
			this.labelProgram2.Name = "labelProgram2";
			this.labelProgram2.Size = new System.Drawing.Size(56, 16);
			this.labelProgram2.TabIndex = 5;
			this.labelProgram2.Text = "Program:";
			// 
			// buttonFileDialog3
			// 
			this.buttonFileDialog3.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.buttonFileDialog3.Location = new System.Drawing.Point(248, 24);
			this.buttonFileDialog3.Name = "buttonFileDialog3";
			this.buttonFileDialog3.Size = new System.Drawing.Size(56, 23);
			this.buttonFileDialog3.TabIndex = 7;
			this.buttonFileDialog3.Text = "Q";
			this.buttonFileDialog3.Click += new System.EventHandler(this.buttonFileDialog3_Click);
			// 
			// textBoxOptionEnd
			// 
			this.textBoxOptionEnd.Location = new System.Drawing.Point(72, 64);
			this.textBoxOptionEnd.Name = "textBoxOptionEnd";
			this.textBoxOptionEnd.Size = new System.Drawing.Size(160, 19);
			this.textBoxOptionEnd.TabIndex = 8;
			this.textBoxOptionEnd.Text = "";
			// 
			// textBoxProgramEnd
			// 
			this.textBoxProgramEnd.Location = new System.Drawing.Point(72, 24);
			this.textBoxProgramEnd.Name = "textBoxProgramEnd";
			this.textBoxProgramEnd.Size = new System.Drawing.Size(160, 19);
			this.textBoxProgramEnd.TabIndex = 6;
			this.textBoxProgramEnd.Text = "";
			// 
			// labelOption2
			// 
			this.labelOption2.Location = new System.Drawing.Point(16, 64);
			this.labelOption2.Name = "labelOption2";
			this.labelOption2.Size = new System.Drawing.Size(48, 16);
			this.labelOption2.TabIndex = 9;
			this.labelOption2.Text = "Option:";
			// 
			// buttonFileDialog4
			// 
			this.buttonFileDialog4.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.buttonFileDialog4.Location = new System.Drawing.Point(248, 64);
			this.buttonFileDialog4.Name = "buttonFileDialog4";
			this.buttonFileDialog4.Size = new System.Drawing.Size(56, 23);
			this.buttonFileDialog4.TabIndex = 9;
			this.buttonFileDialog4.Text = "Q";
			this.buttonFileDialog4.Click += new System.EventHandler(this.buttonFileDialog4_Click);
			// 
			// ItemForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 12);
			this.ClientSize = new System.Drawing.Size(322, 344);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.groupBoxRemove,
																		  this.groupBoxRecognize,
																		  this.buttonCancel,
																		  this.buttonOK,
																		  this.textBoxName,
																		  this.labelName,
																		  this.labelTitle,
																		  this.labelId,
																		  this.textBoxId});
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.Name = "ItemForm";
			this.Text = "ItemForm";
			this.groupBoxRecognize.ResumeLayout(false);
			this.groupBoxRemove.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

	}
}
